backend/apps/api/urls.py
from django.urls import path

from apps.api.views import list_active_transportation, transportation_control, receive_transportation_tx, \
    finalize_transportation

app_name = 'api'

urlpatterns = [
    path('transportation/', list_active_transportation, name='list-active-transportation'),
    path('transportation/control/', transportation_control, name='transportation-control'),
    path('transportation/start_running/', receive_transportation_tx, name='receive-transportation-tx'),
    path('transportation/finalize/', finalize_transportation, name='finalize-transportation'),
]

backend/apps/transportation/urls.py
from django.urls import path

from apps.transportation.views import TransportationListView

urlpatterns = [
    path('list/', TransportationListView.as_view(), name='transportation-list'),
]

backend/backend/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),

    path('api/', include('apps.api.urls')),
    path('transportation/', include('apps.transportation.urls')),
]

backend/apps/api/models.py
import base64
import secrets
import uuid as uuid
from urllib.parse import urlencode

from django.contrib.auth.models import User
from django.contrib.postgres.fields import JSONField
from django.contrib.gis.db import models

from django.contrib.gis.db.models import PointField
from django.db import transaction
from django.db.models.signals import post_save
from django.dispatch import receiver

from apps.api import utils
from apps.catalog.models import HazardousMaterial


class UserProfile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    phone = models.CharField(max_length=20, blank=True, null=True)

    def __str__(self):
        return f"{self.user}'s profile"


class Device(models.Model):
    uuid = models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True)
    user = models.ForeignKey(User, on_delete=models.CASCADE)


class Transportation(models.Model):
    STATUS_CREATED = 'created'
    STATUS_ACTIVE = 'active'
    STATUS_FINISHED = 'finished'
    STATUS_ARBITRAGE = 'arbitrage'
    STATUS_CHOICES = (
        (STATUS_CREATED, "Created"),
        (STATUS_ACTIVE, "Active"),
        (STATUS_FINISHED, "Finished"),
        (STATUS_ARBITRAGE, "Arbitrage"),
    )
    device = models.ForeignKey(Device, on_delete=models.CASCADE)
    start_point = PointField()
    end_point = PointField()
    status = models.CharField(max_length=255, choices=STATUS_CHOICES, default=STATUS_CREATED)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    seed = models.CharField(max_length=81, blank=True)
    key = models.CharField(max_length=81, blank=True)
    first_root = models.CharField(max_length=255, blank=True, null=True)
    last_root = models.CharField(max_length=255, blank=True, null=True)
    type_of_hazardous_material = models.ForeignKey(
        HazardousMaterial, on_delete=models.CASCADE, blank=True, null=True
    )
    volume = models.FloatField(blank=True, null=True, help_text="Volume in tons")
    distance = models.FloatField(blank=True, null=True, help_text="Distance in km")
    key_trytes = models.CharField(max_length=255, blank=True, null=True)

    risk_value = models.FloatField(blank=True, null=True)
    stake = models.FloatField(blank=True, null=True)
    tx_address = models.CharField(max_length=255, blank=True, null=True)

    data = JSONField(blank=True, null=True)

    @transaction.atomic
    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        if self.pk is None:
            self.seed = utils.generate_seed()
            self.key = secrets.token_hex(40)
            self.first_root, self.key_trytes = utils.get_first_root(self.seed, self.key)
            self.risk_value = self.get_stake_for_transportation()
            self.stake = self.risk_value

        return super(Transportation, self).save(force_insert, force_update, using, update_fields)

    def get_stake_for_transportation(self):
        return (self.volume * self.distance * self.type_of_hazardous_material.coefficient) / 100

    def get_encrypted_payload(self):
        payload = {
            'start_point': f'{self.start_point[1]}+{self.start_point[0]}',
            'end_point': f'{self.end_point[1]}+{self.end_point[0]}',
        }
        payload = urlencode(payload)

        return base64.b64encode(payload.encode()).decode("utf-8")

    def check_finish(self):
        try:
            last_checkpoint = Checkpoint.objects.filter(transportation=self).order_by('-id')[0]
            distance = utils.calculate_distance(self.end_point[1], self.end_point[0], last_checkpoint.location[1],
                                                last_checkpoint.location[0])
            print("dist %s" % distance)
            if distance < 5:
                return True
        except IndexError:
            return False

    def finish(self):
        if self.check_finish():
            self.status = Transportation.STATUS_FINISHED
            self.save()
            return True

        return False


class Checkpoint(models.Model):
    uuid = models.UUIDField(default=uuid.uuid4, editable=False)
    location = PointField()
    transportation = models.ForeignKey(Transportation, on_delete=models.CASCADE)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    data = JSONField(blank=True, null=True)


@receiver(post_save, sender=User)
def create_or_update_user_profile(sender, instance, created, **kwargs):
    if created:
        UserProfile.objects.create(user=instance)
    instance.userprofile.save()

backend/apps/transportation/views.py
from django.conf import settings
from django.views.generic import TemplateView

from apps.api.models import Transportation


class TransportationListView(TemplateView):
    template_name = 'transportation/list.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['transportations'] = Transportation.objects.all().order_by('-id')
        return context

backend/apps/transportation/templates/transportation/list.html
{% extends 'base.html' %}
{% block js_imports %}
{% endblock %}
{% block content %}
    {{ block.super }}
    <br>
    <div class="row">
        <div class="center" style="width: 100%; text-align: center; margin-bottom: 20px">
            <img src="http://www.wildeman-sl.nl/wp-content/uploads/2014/12/Logo-Wildeman-Storage-en-Logistics.jpg" alt="" width="150px" height="50">
            <h4>My Transportations</h4>

        </div>
    </div>

    <div class="row">
        <div class="col-md-3">
            <a class="btn btn-primary" href="{% url 'admin:api_transportation_add' %}">Create new Transportation</a>
        </div>
    </div>
    <br>
    <table class="table table-hover">
        <thead>
        <tr>
            <th>ID</th>
            <th>Created</th>
            <th>Type of material</th>
            <th>Volume (tons)</th>
            <th>Distance (km)</th>
            <th>Risk</th>
            <th>Status</th>
            <th></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        {% for transportation in transportations %}
        <tr>
            <td>{{ transportation.pk }}</td>
            <td>{{ transportation.created_at }}</td>
            <td>{{ transportation.type_of_hazardous_material.kind }}</td>
            <td>{{ transportation.volume }}</td>
            <td>{{ transportation.distance }}</td>
            <td>{{ transportation.risk_value }}</td>
            <td>{{ transportation.get_status_display }}</td>
            <td><a target="_blank" href="https://mam-explorer.firebaseapp.com/?provider=https://nodes.devnet.iota.org:443&mode=restricted&root={{ transportation.first_root }}&key={{ transportation.key_trytes }}">Checkpoint</a></td>
            <td>
            {% if transportation.status == transportation.STATUS_CREATED %}
                <a
                        href="#"
                        class="start"
                        data-payload="{{ transportation.get_encrypted_payload }}"
                        data-root="{{ transportation.first_root }}"
                        data-id="{{ transportation.pk }}"
                        data-stake="{{ transportation.stake }}"
                >
                    <button type="button" class="btn btn-success">Start</button>
                </a>
            {% elif transportation.status == transportation.STATUS_ACTIVE %}
                <a href="#" class="finalize" data-id="{{ transportation.pk }}">
                    <button type="button" class="btn btn-danger">Finish</button>
                </a>
            {% elif transportation.status == transportation.STATUS_FINISHED %}
                <button type="button" class="btn btn-default" disabled>Finished</button>
            {% endif %}
        </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

{% block scripts %}
    {{ block.super }}
    <script type="application/javascript">
    $(document).ready(function() {
        $(".start").click(async function (e) {
            e.preventDefault();
            var payload = $(this).data("payload");
            var root = $(this).data("root");
            var stake = $(this).data("stake");
            var transportation_id = $(this).data("id");

            $.post("{% url 'api:receive-transportation-tx' %}", {
                'transportation_id': transportation_id,
            }, function( data ) {
                if (data.success) {
                    location.reload();
                }
                else {
                    alert('Could not start this transportation.')
                }
            });

        });
        $('.finalize').click(function (e) {
            e.preventDefault();
            var transportation_id = $(this).data("id");
            $.post(
                "{% url 'api:finalize-transportation' %}", {'transportation_id': transportation_id,}, function( data ) {
                    if (data.success) {
                        location.reload();
                    }
                    else {
                        alert('Could not finish this transportation.')
                    }
                });
        })
    })

    </script>
{% endblock %}